// A tone library for arduino - using a passive buzzer
// Changelog
// 20190703: NEW
#pragma once
#include "B4RDefines.h"
#include "Tone.h"

namespace B4R {
	//~Version: 1.0
	//~shortname: Tone
	class B4RTone {
		private:
			Tone* bn;
			uint8_t be[sizeof(Tone)];
		public:
		
			/**
			*Initialize with the pin number that the buzzer Vcc is connected to
			*/			
			void initialize(Byte tonePin);
			/**
			*Is a tone playing?
			*/					
			bool isPlaying();
			/**
			*frequency (in hertz) and duration (in milliseconds).
			*/					
			void play(UInt frequency, ULong duration = 0);
			/**
			*Stop playing the active tone
			*/					
			void stop();	

			/**
			*Frequency = 31
			*/		            
			UInt NOTE_B0 =  31;
			/**
			*Frequency = 33
			*/				
			UInt NOTE_C1 =  33;
			/**
			*Frequency = 35
			*/				
			UInt NOTE_CS1 = 35;
			/**
			*Frequency = 37
			*/				
			UInt NOTE_D1 =  37;
			/**
			*Frequency = 39
			*/				
			UInt NOTE_DS1 = 39;
			/**
			*Frequency = 41
			*/				
			UInt NOTE_E1 =  41;
			/**
			*Frequency = 44
			*/				
			UInt NOTE_F1 =  44;
			/**
			*Frequency = 46
			*/				
			UInt NOTE_FS1 = 46;
			/**
			*Frequency = 49
			*/				
			UInt NOTE_G1 =  49;
			/**
			*Frequency = 52
			*/				
			UInt NOTE_GS1 = 52;
			/**
			*Frequency = 55
			*/				
			UInt NOTE_A1 =  55;
			/**
			*Frequency = 58
			*/				
			UInt NOTE_AS1 = 58;
			/**
			*Frequency = 62
			*/				
			UInt NOTE_B1 =  62;
			/**
			*Frequency = 65
			*/				
			UInt NOTE_C2 =  65;
			/**
			*Frequency = 69
			*/				
			UInt NOTE_CS2 = 69;
			/**
			*Frequency = 73
			*/				
			UInt NOTE_D2 =  73;
			/**
			*Frequency = 78
			*/				
			UInt NOTE_DS2 = 78;
			/**
			*Frequency = 82
			*/				
			UInt NOTE_E2 =  82;
			/**
			*Frequency = 87
			*/				
			UInt NOTE_F2 =  87;
			/**
			*Frequency = 93
			*/				
			UInt NOTE_FS2 = 93;
			/**
			*Frequency = 98
			*/				
			UInt NOTE_G2 =  98;
			/**
			*Frequency = 104
			*/				
			UInt NOTE_GS2 = 104;
			/**
			*Frequency = 110
			*/				
			UInt NOTE_A2 =  110;
			/**
			*Frequency = 117
			*/
			UInt NOTE_AS2 = 117;
			/**
			*Frequency = 123
			*/
			UInt NOTE_B2 =  123;
			/**
			*Frequency = 131
			*/
			UInt NOTE_C3 =  131;
			/**
			*Frequency = 139
			*/
			UInt NOTE_CS3 = 139;
			/**
			*Frequency = 147
			*/
			UInt NOTE_D3 =  147;
			/**
			*Frequency = 156
			*/
			UInt NOTE_DS3 = 156;
			/**
			*Frequency = 165
			*/
			UInt NOTE_E3 =  165;
			/**
			*Frequency = 175
			*/
			UInt NOTE_F3 =  175;
			/**
			*Frequency = 185
			*/
			UInt NOTE_FS3 = 185;
			/**
			*Frequency = 196
			*/
			UInt NOTE_G3 =  196;
			/**
			*Frequency = 208
			*/
			UInt NOTE_GS3 = 208;
			/**
			*Frequency = 220
			*/
			UInt NOTE_A3 =  220;
			/**
			*Frequency = 233
			*/
			UInt NOTE_AS3 = 233;
			/**
			*Frequency = 247
			*/
			UInt NOTE_B3 =  247;
			/**
			*Frequency = 262
			*/
			UInt NOTE_C4 =  262;
			/**
			*Frequency = 277
			*/
			UInt NOTE_CS4 = 277;
			/**
			*Frequency = 294
			*/
			UInt NOTE_D4 =  294;
			/**
			*Frequency = 311
			*/
			UInt NOTE_DS4 = 311;
			/**
			*Frequency = 330
			*/
			UInt NOTE_E4 =  330;
			/**
			*Frequency = 349
			*/
			UInt NOTE_F4 =  349;
			/**
			*Frequency = 370
			*/
			UInt NOTE_FS4 = 370;
			/**
			*Frequency = 392
			*/
			UInt NOTE_G4 =  392;
			/**
			*Frequency = 415
			*/
			UInt NOTE_GS4 = 415;
			/**
			*Frequency = 440
			*/
			UInt NOTE_A4 =  440;
			/**
			*Frequency = 466
			*/
			UInt NOTE_AS4 = 466;
			/**
			*Frequency = 494
			*/
			UInt NOTE_B4 =  494;
			/**
			*Frequency = 523
			*/
			UInt NOTE_C5 =  523;
			/**
			*Frequency = 554
			*/
			UInt NOTE_CS5 = 554;
			/**
			*Frequency = 587
			*/
			UInt NOTE_D5 =  587;
			/**
			*Frequency = 622
			*/
			UInt NOTE_DS5 = 622;
			/**
			*Frequency = 659
			*/
			UInt NOTE_E5 =  659;
			/**
			*Frequency = 698
			*/
			UInt NOTE_F5 =  698;
			/**
			*Frequency = 740
			*/
			UInt NOTE_FS5 = 740;
			/**
			*Frequency = 784
			*/
			UInt NOTE_G5 =  784;
			/**
			*Frequency = 831
			*/
			UInt NOTE_GS5 = 831;
			/**
			*Frequency = 880
			*/
			UInt NOTE_A5 =  880;
			/**
			*Frequency = 932
			*/
			UInt NOTE_AS5 = 932;
			/**
			*Frequency = 988
			*/
			UInt NOTE_B5 =  988;
			/**
			*Frequency = 1047
			*/
			UInt NOTE_C6 =  1047;
			/**
			*Frequency = 1109
			*/
			UInt NOTE_CS6 = 1109;
			/**
			*Frequency = 1175
			*/
			UInt NOTE_D6 =  1175;
			/**
			*Frequency = 1245
			*/
			UInt NOTE_DS6 = 1245;
			/**
			*Frequency = 1319
			*/
			UInt NOTE_E6 =  1319;
			/**
			*Frequency = 1397
			*/
			UInt NOTE_F6 =  1397;
			/**
			*Frequency = 1480
			*/
			UInt NOTE_FS6 = 1480;
			/**
			*Frequency = 1568
			*/
			UInt NOTE_G6 =  1568;
			/**
			*Frequency = 1661
			*/
			UInt NOTE_GS6 = 1661;
			/**
			*Frequency = 1760
			*/
			UInt NOTE_A6 =  1760;
			/**
			*Frequency = 1865
			*/
			UInt NOTE_AS6 = 1865;
			/**
			*Frequency = 1976
			*/
			UInt NOTE_B6 =  1976;
			/**
			*Frequency = 2093
			*/
			UInt NOTE_C7 =  2093;
			/**
			*Frequency = 2217
			*/
			UInt NOTE_CS7 = 2217;
			/**
			*Frequency = 2349
			*/
			UInt NOTE_D7 =  2349;
			/**
			*Frequency = 2489
			*/
			UInt NOTE_DS7 = 2489;
			/**
			*Frequency = 2637
			*/
			UInt NOTE_E7 =  2637;
			/**
			*Frequency = 2794
			*/
			UInt NOTE_F7 =  2794;
			/**
			*Frequency = 2960
			*/
			UInt NOTE_FS7 = 2960;
			/**
			*Frequency = 3136
			*/
			UInt NOTE_G7 =  3136;
			/**
			*Frequency = 3322
			*/
			UInt NOTE_GS7 = 3322;
			/**
			*Frequency = 3520
			*/
			UInt NOTE_A7 =  3520;
			/**
			*Frequency = 3729
			*/
			UInt NOTE_AS7 = 3729;
			/**
			*Frequency = 3951
			*/
			UInt NOTE_B7 =  3951;
			/**
			*Frequency = 4186
			*/
			UInt NOTE_C8 =  4186;
			/**
			*Frequency = 4435
			*/
			UInt NOTE_CS8 = 4435;
			/**
			*Frequency = 4699
			*/
			UInt NOTE_D8 =  4699;
			/**
			*Frequency = 4978
			*/
			UInt NOTE_DS8 = 4978;
	};

}